(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     59288,       1543]
NotebookOptionsPosition[     58829,       1524]
NotebookOutlinePosition[     59240,       1542]
CellTagsIndexPosition[     59197,       1539]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"<<", "\"\<Combinatorica`\>\""}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "All", " ", "letters", " ", "are", " ", "accepted", " ", "and", " ", 
      "mapped", " ", "to", " ", "0"}], ",", "1", ",", "2", ",", "3", ",", 
     RowBox[{
     "...", " ", "by", " ", "input", " ", "order", " ", "to", " ", "express", 
      " ", "colours"}]}], " ", "*)"}], " ", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "If", " ", "the", " ", "#", " ", "of", " ", "letters", " ", "is", " ", 
      "less", " ", "then", " ", "10"}], ",", " ", 
     RowBox[{
     "it", " ", "is", " ", "simpler", " ", "to", " ", "use", " ", "0"}], ",", 
     "1", ",", "2", ",", "3", ",", "..."}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<0102\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<12\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<130\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<01\>\""}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<0231\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<2103\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<23\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<10\>\""}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<013121\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<2130212110\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<013\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<012\>\""}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<03\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<0\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<121\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<02\>\""}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<01\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<00\>\""}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<32\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<3\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<01\>\""}]}], "}"}]}], ";", 
    RowBox[{"(*", " ", 
     RowBox[{"Symmetric", " ", "Fibonacci"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<2\>\""}], ",", 
       RowBox[{"\"\<2\>\"", " ", "\[Rule]", "\"\<543\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "->", "\"\<4\>\""}], ",", 
       RowBox[{"\"\<4\>\"", "\[Rule]", "\"\<5\>\""}], ",", 
       RowBox[{"\"\<5\>\"", "\[Rule]", "\"\<012\>\""}]}], "}"}]}], ";", 
    RowBox[{"(*", " ", 
     RowBox[{"Symmetric", " ", "Tribonacci"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<051000\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<324100\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<24100\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<324333\>\""}], ",", 
       RowBox[{"\"\<4\>\"", "\[Rule]", "\"\<051433\>\""}], ",", 
       RowBox[{"\"\<5\>\"", "\[Rule]", "\"\<51433\>\""}]}], "}"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Example", " ", "5.1", " ", "by", " ", "Barge"}], "-", 
      "Kwapisz"}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<03\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<0\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<21\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<2\>\""}]}], "}"}]}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{"Example", " ", "5.1", " ", "by", " ", 
      RowBox[{"B", ".", " ", "Sing"}]}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<0102\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<12\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<130\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<01\>\""}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<051000\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<324100\>\""}], ",", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<24100\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<324333\>\""}], ",", 
       RowBox[{"\"\<4\>\"", "\[Rule]", "\"\<051433\>\""}], ",", 
       RowBox[{"\"\<5\>\"", "\[Rule]", "\"\<51433\>\""}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Rl", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<0\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<2\>\""}], ",", 
       RowBox[{"\"\<2\>\"", " ", "\[Rule]", "\"\<345\>\""}], ",", 
       RowBox[{"\"\<3\>\"", "->", "\"\<4\>\""}], ",", 
       RowBox[{"\"\<4\>\"", "\[Rule]", "\"\<5\>\""}], ",", 
       RowBox[{"\"\<5\>\"", "\[Rule]", "\"\<012\>\""}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rl", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<b\>\"", "\[Rule]", "\"\<ca\>\""}], ",", 
      RowBox[{"\"\<a\>\"", "\[Rule]", "\"\<bc\>\""}], ",", 
      RowBox[{"\"\<c\>\"", "\[Rule]", "\"\<a\>\""}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tb", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Map", "[", 
     RowBox[{"ToCharacterCode", ",", 
      RowBox[{"Map", "[", 
       RowBox[{"First", ",", "Rl"}], "]"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ToSt", "=", 
   RowBox[{"Function", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FromCharacterCode", "[", 
      RowBox[{"Tb", "[", 
       RowBox[{"[", 
        RowBox[{"x", "+", "1"}], "]"}], "]"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"k", "=", 
   RowBox[{"Length", "[", "Rl", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"StringPosition", "[", 
          RowBox[{"#1", ",", 
           RowBox[{"ToSt", "[", "i", "]"}]}], "]"}], "]"}], "&"}], ")"}], "/@", 
      RowBox[{"Last", "/@", "Rl"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", 
       RowBox[{"k", "-", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "+", "#2"}], "&"}], ",", "0", ",", 
       RowBox[{"Flatten", "[", "A1", "]"}]}], "]"}], "<", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "+", "#2"}], "&"}], ",", "0", ",", 
       RowBox[{"Map", "[", 
        RowBox[{"StringLength", ",", 
         RowBox[{"Map", "[", 
          RowBox[{"Last", ",", "Rl"}], "]"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{
     RowBox[{
     "Print", "[", 
      "\"\<Not Irreducible: Some letter appears without input.\>\"", "]"}], 
     ";", 
     RowBox[{"Interrupt", "[", "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TL", "=", 
   RowBox[{"First", "[", 
    RowBox[{"Last", "[", 
     RowBox[{"Eigensystem", "[", 
      RowBox[{"Transpose", "[", "A1", "]"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eg", "=", 
   RowBox[{"Sort", "[", 
    RowBox[{
     RowBox[{"Eigenvalues", "[", "A1", "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<=", 
       RowBox[{"N", "[", 
        RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Flist", "=", 
   RowBox[{"First", "/@", 
    RowBox[{"FactorList", "[", 
     RowBox[{"CharacteristicPolynomial", "[", 
      RowBox[{"A1", ",", "x"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Flist", "=", 
   RowBox[{"Delete", "[", 
    RowBox[{"Flist", ",", 
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"NumberQ", "/@", "Flist"}], ",", "True"}], "]"}]}], "]"}]}], 
  ";", 
  RowBox[{"FlistSol", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Max", "[", 
       RowBox[{"Abs", "[", "#1", "]"}], "]"}], "&"}], ")"}], "/@", 
    RowBox[{"(", 
     RowBox[{"x", "/.", "\[InvisibleSpace]", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"z", ",", 
         RowBox[{"NSolve", "[", 
          RowBox[{"z", ",", "x"}], "]"}]}], "]"}], "/@", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"#1", "\[Equal]", "0"}], "&"}], ")"}], "/@", "Flist"}]}]}], 
     ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Fd", "=", 
   RowBox[{"First", "[", 
    RowBox[{"Extract", "[", 
     RowBox[{"Flist", ",", 
      RowBox[{"Position", "[", 
       RowBox[{"FlistSol", ",", 
        RowBox[{"Max", "[", "FlistSol", "]"}]}], "]"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Graphics", "[", 
    RowBox[{"Circle", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", "1"}], "]"}], "]"}], ",", 
   RowBox[{"Graphics", "/@", 
    RowBox[{"Point", "/@", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Re", "[", "#1", "]"}], ",", 
           RowBox[{"Im", "[", "#1", "]"}]}], "}"}], "&"}], ")"}], "/@", 
       "Eg"}], "]"}]}]}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eg0", "=", 
   RowBox[{"Sort", "[", 
    RowBox[{
     RowBox[{"x", "/.", "\[InvisibleSpace]", 
      RowBox[{"NSolve", "[", 
       RowBox[{
        RowBox[{"Fd", "\[Equal]", "0"}], ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<", 
       RowBox[{"N", "[", 
        RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "Eg0", "]"}], "<", 
     RowBox[{"Length", "[", "Eg", "]"}]}], ",", 
    RowBox[{
    "Print", "[", "\"\<Reducible characteristic polynomial\>\"", "]"}]}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "Eg0", "]"}], "\[Equal]", "1"}], "||", 
     RowBox[{"1", ">", 
      RowBox[{"Max", "[", 
       RowBox[{"Abs", "[", 
        RowBox[{"Drop", "[", 
         RowBox[{"Eg0", ",", 
          RowBox[{"-", "1"}]}], "]"}], "]"}], "]"}]}]}], ",", 
    RowBox[{"Print", "[", "\"\<Pisot\>\"", "]"}], ",", 
    RowBox[{
     RowBox[{
     "Print", "[", "\"\<Non Pisot: Program will not terminate.\>\"", "]"}], 
     ";", 
     RowBox[{"Interrupt", "[", "]"}], ";"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Diameter", "[", 
      RowBox[{"FromAdjacencyMatrix", "[", 
       RowBox[{"A1", ",", 
        RowBox[{"Type", "\[Rule]", "Directed"}]}], "]"}], "]"}], "\[Equal]", 
     "Infinity"}], ",", 
    RowBox[{"Print", "[", "\"\<Not Irreducible\>\"", "]"}], ",", 
    RowBox[{"Print", "[", "\"\<Irreducible\>\"", "]"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Abs", "[", 
      RowBox[{
       RowBox[{"Abs", "[", 
        RowBox[{"Eg", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}], "]"}], "-", 
       RowBox[{"Abs", "[", 
        RowBox[{"Eg", "[", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}], "]"}], "]"}]}], "]"}], "<", 
     RowBox[{"100", "*", "$MachineEpsilon"}]}], ",", 
    RowBox[{
     RowBox[{"Print", "[", "\"\<Not Primitive\>\"", "]"}], ";", 
     RowBox[{"Interrupt", "[", "]"}]}], ",", 
    RowBox[{"Print", "[", "\"\<Primitive\>\"", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"N", "[", "Eg", "]"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.45464759696875*^9, 3.4546476670625*^9}, {
   3.45464771334375*^9, 3.4546477173125*^9}, {3.4546477731875*^9, 
   3.454647782953125*^9}, 3.45464781959375*^9, {3.45464812659375*^9, 
   3.454648151203125*^9}, {3.454648242390625*^9, 3.454648315765625*^9}, {
   3.454648352234375*^9, 3.454648528578125*^9}, {3.45464863740625*^9, 
   3.454648751640625*^9}, 3.45464895559375*^9, {3.4546490714375*^9, 
   3.45464907275*^9}, {3.4546496735625*^9, 3.45464968221875*^9}, 
   3.454662942234375*^9, 3.454663049765625*^9, {3.454713619671875*^9, 
   3.454713620890625*^9}, {3.454784181703125*^9, 3.454784196265625*^9}, {
   3.454784227484375*^9, 3.454784368671875*^9}, {3.454784413125*^9, 
   3.454784414015625*^9}, {3.454796276203125*^9, 3.45479628921875*^9}, {
   3.475758457040493*^9, 3.47575846111909*^9}, {3.475758610781962*^9, 
   3.4757586169521103`*^9}, {3.475758798627507*^9, 3.47575880141816*^9}, {
   3.475758869504044*^9, 3.475758889440987*^9}, {3.475758924021473*^9, 
   3.475758949352518*^9}, {3.475759007214953*^9, 3.4757590644093122`*^9}, {
   3.475759131314268*^9, 3.475759175310017*^9}, {3.4767998138861713`*^9, 
   3.4767998410871973`*^9}, {3.4768002535658283`*^9, 3.476800289983285*^9}, {
   3.476800332535603*^9, 3.4768003528184347`*^9}, {3.4768003889354277`*^9, 
   3.476800435149364*^9}, {3.476875601817428*^9, 3.4768756036224194`*^9}, {
   3.476875667953071*^9, 3.476875722584241*^9}, {3.476875766463079*^9, 
   3.476875835709003*^9}, {3.476878600529175*^9, 3.476878767830502*^9}, {
   3.476878812206868*^9, 3.4768788337815943`*^9}, {3.476878909696877*^9, 
   3.4768789187900133`*^9}, {3.476878971512916*^9, 3.4768790103788977`*^9}, {
   3.47687906958848*^9, 3.476879071361655*^9}, {3.4768792186475773`*^9, 
   3.476879267059414*^9}, {3.4768795635274763`*^9, 3.476879568875654*^9}, {
   3.476880203978857*^9, 3.47688024940303*^9}, 3.476880295412281*^9, {
   3.476880847729097*^9, 3.476880850498273*^9}, {3.476881570613863*^9, 
   3.4768816238223124`*^9}, {3.476881666343392*^9, 3.4768816747772713`*^9}, 
   3.47688184916523*^9, {3.4768820297874002`*^9, 3.4768820346158133`*^9}, {
   3.476882080627096*^9, 3.476882081777871*^9}, {3.476882150922748*^9, 
   3.476882220471236*^9}, {3.476882307577854*^9, 3.476882320842257*^9}, 
   3.476883756966832*^9, {3.4768838880064287`*^9, 3.476883897623069*^9}, {
   3.4768844816048603`*^9, 3.476884486736443*^9}, 3.476884568525353*^9, {
   3.476884609070751*^9, 3.4768846099398327`*^9}, {3.476884641663525*^9, 
   3.476884642939644*^9}, {3.47688514643548*^9, 3.476885161042385*^9}, {
   3.476885225021987*^9, 3.476885226372568*^9}, {3.476888155684713*^9, 
   3.476888204430585*^9}, {3.476888276694442*^9, 3.476888320643654*^9}, 
   3.476888356910417*^9, {3.4768883929485073`*^9, 3.476888394132023*^9}, {
   3.476941828147929*^9, 3.476941829121776*^9}, {3.476941862941679*^9, 
   3.4769418640988817`*^9}, {3.476941985065732*^9, 3.4769420091129513`*^9}, {
   3.476942083525141*^9, 3.476942084331417*^9}, {3.4769422041808147`*^9, 
   3.4769422170784388`*^9}, {3.476942257090872*^9, 3.4769422717204723`*^9}, {
   3.476942367118573*^9, 3.476942387822585*^9}, {3.476943528042822*^9, 
   3.476943576235745*^9}, {3.476944378126449*^9, 3.476944449216949*^9}, {
   3.476944581318825*^9, 3.476944595678013*^9}, {3.476944638048341*^9, 
   3.476944651240032*^9}, {3.476944681771864*^9, 3.476944813311153*^9}, {
   3.476945049751347*^9, 3.4769450500284367`*^9}, {3.4769453989393263`*^9, 
   3.476945439301465*^9}, {3.476945958243029*^9, 3.476945963570505*^9}, {
   3.476946134034319*^9, 3.476946147880438*^9}, 3.476946214462646*^9, {
   3.476946291837669*^9, 3.476946307187887*^9}, {3.476946362487207*^9, 
   3.476946575407064*^9}, {3.47694664799605*^9, 3.476946682919467*^9}, 
   3.4769467430346746`*^9, {3.476946833263633*^9, 3.476946895036083*^9}, 
   3.476947097374837*^9, {3.476947184000505*^9, 3.47694721864574*^9}, {
   3.476947289265451*^9, 3.476947292875111*^9}, {3.476947345185631*^9, 
   3.476947443128912*^9}, {3.476948108297845*^9, 3.47694811354501*^9}, {
   3.4769690870887403`*^9, 3.476969105199938*^9}, {3.477206002945952*^9, 
   3.477206039599208*^9}, {3.477206281986885*^9, 3.477206297066484*^9}, {
   3.4772064618668537`*^9, 3.477206480672843*^9}, {3.477206571000907*^9, 
   3.477206613426735*^9}, {3.494999319198943*^9, 3.49499932920372*^9}, {
   3.494999396573151*^9, 3.49499941370592*^9}, {3.494999554869384*^9, 
   3.494999594916686*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Choose", " ", "some", " ", "power", " ", "of", " ", "substitution", " ", 
    "to", " ", "obtain", " ", "a", " ", "fixed", " ", "point"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Rp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"While", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Or", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", "False", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"StringTake", "[", 
             RowBox[{
              RowBox[{"Nest", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"StringReplace", "[", 
                  RowBox[{"#", ",", "Rl"}], "]"}], "&"}], ",", 
                RowBox[{"ToSt", "[", "i", "]"}], ",", "Rp"}], "]"}], ",", 
              "1"}], "]"}], "\[Equal]", 
            RowBox[{"ToSt", "[", "i", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{
              RowBox[{"Length", "[", "Rl", "]"}], "-", "1"}]}], "}"}]}], 
          "]"}]}], "]"}], "\[Equal]", "False"}], ",", 
      RowBox[{"Rp", "++"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Rl", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ToSt", "[", "i", "]"}], "->", 
        RowBox[{"Nest", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"StringReplace", "[", 
            RowBox[{"#", ",", "Rl"}], "]"}], "&"}], ",", 
          RowBox[{"ToSt", "[", "i", "]"}], ",", "Rp"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{
          RowBox[{"Length", "[", "Rl", "]"}], "-", "1"}]}], "}"}]}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", "Rl", "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"wpos", "=", 
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"StringTake", "[", 
           RowBox[{
            RowBox[{"StringReplace", "[", 
             RowBox[{
              RowBox[{"ToSt", "[", "i", "]"}], ",", "Rl"}], "]"}], ",", "1"}],
            "]"}], "\[Equal]", 
          RowBox[{"ToSt", "[", "i", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{
            RowBox[{"Length", "[", "Rl", "]"}], "-", "1"}]}], "}"}]}], "]"}], 
       ",", "True"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"lpos", "=", 
     RowBox[{"Extract", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"StringLength", ",", 
         RowBox[{"Map", "[", 
          RowBox[{"Last", ",", "Rl"}], "]"}]}], "]"}], ",", "wpos"}], "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"w", "=", 
     RowBox[{"ToSt", "[", 
      RowBox[{
       RowBox[{"First", "[", 
        RowBox[{"Extract", "[", 
         RowBox[{"wpos", ",", 
          RowBox[{"First", "[", 
           RowBox[{"Position", "[", 
            RowBox[{"lpos", ",", 
             RowBox[{"Max", "[", "lpos", "]"}]}], "]"}], "]"}]}], "]"}], 
        "]"}], "-", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Use a fix point begins with \>\"", ",", "w"}], "]"}], ";"}],
    " ", "\n", 
   RowBox[{
    RowBox[{"k", "=", 
     RowBox[{"Length", "[", "Rl", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"A1", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"StringPosition", "[", 
            RowBox[{"#1", ",", 
             RowBox[{"ToSt", "[", "i", "]"}]}], "]"}], "]"}], "&"}], ")"}], "/@", 
        RowBox[{"Last", "/@", "Rl"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"k", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TL", "=", 
     RowBox[{"First", "[", 
      RowBox[{"Last", "[", 
       RowBox[{"Eigensystem", "[", 
        RowBox[{"Transpose", "[", "A1", "]"}], "]"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Eg", "=", 
     RowBox[{"Sort", "[", 
      RowBox[{
       RowBox[{"Eigenvalues", "[", "A1", "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "[", 
          RowBox[{"Abs", "[", "#1", "]"}], "]"}], "<=", 
         RowBox[{"N", "[", 
          RowBox[{"Abs", "[", "#2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Flist", "=", 
     RowBox[{"First", "/@", 
      RowBox[{"FactorList", "[", 
       RowBox[{"CharacteristicPolynomial", "[", 
        RowBox[{"A1", ",", "x"}], "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Flist", "=", 
     RowBox[{"Delete", "[", 
      RowBox[{"Flist", ",", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"NumberQ", "/@", "Flist"}], ",", "True"}], "]"}]}], "]"}]}], 
    ";", 
    RowBox[{"FlistSol", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Max", "[", 
         RowBox[{"Abs", "[", "#1", "]"}], "]"}], "&"}], ")"}], "/@", 
      RowBox[{"(", 
       RowBox[{"x", "/.", "\[InvisibleSpace]", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"NSolve", "[", 
            RowBox[{"z", ",", "x"}], "]"}]}], "]"}], "/@", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#1", "\[Equal]", "0"}], "&"}], ")"}], "/@", 
          "Flist"}]}]}], ")"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Fd", "=", 
     RowBox[{"First", "[", 
      RowBox[{"Extract", "[", 
       RowBox[{"Flist", ",", 
        RowBox[{"Position", "[", 
         RowBox[{"FlistSol", ",", 
          RowBox[{"Max", "[", "FlistSol", "]"}]}], "]"}]}], "]"}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"AlgSol", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"AlgebraicNumber", "[", 
         RowBox[{
          RowBox[{"Root", "[", 
           RowBox[{"Fd", ",", "#1"}], "]"}], ",", 
          RowBox[{"PadRight", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"Length", "[", 
             RowBox[{"CoefficientList", "[", 
              RowBox[{"Fd", ",", "x"}], "]"}], "]"}]}], "]"}]}], "]"}], "&"}],
        ")"}], "/@", 
      RowBox[{"Range", "[", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"CoefficientList", "[", 
          RowBox[{"Fd", ",", "x"}], "]"}], "]"}], "-", "1"}], "]"}]}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"Rep", "=", 
     RowBox[{
      RowBox[{"Last", "[", "Eg", "]"}], "\[Rule]", 
      RowBox[{"ToNumberField", "[", 
       RowBox[{
        RowBox[{"Last", "[", "Eg", "]"}], ",", 
        RowBox[{"Root", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Fd", "/.", "\[InvisibleSpace]", 
            RowBox[{"x", "\[Rule]", "#1"}]}], "&"}], ",", 
          RowBox[{"First", "[", 
           RowBox[{"First", "[", 
            RowBox[{"Position", "[", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"AlgSol", "//", "N"}], "]"}], ",", 
              RowBox[{"Max", "[", 
               RowBox[{"Abs", "[", 
                RowBox[{"AlgSol", "//", "N"}], "]"}], "]"}]}], "]"}], "]"}], 
           "]"}]}], "]"}]}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"TL0", "=", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{"z", ",", 
        RowBox[{"ToNumberField", "[", 
         RowBox[{"z", ",", 
          RowBox[{"Root", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Fd", "/.", "\[InvisibleSpace]", 
              RowBox[{"x", "\[Rule]", "#1"}]}], "&"}], ",", 
            RowBox[{"First", "[", 
             RowBox[{"First", "[", 
              RowBox[{"Position", "[", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{"AlgSol", "//", "N"}], "]"}], ",", 
                RowBox[{"Max", "[", 
                 RowBox[{"Abs", "[", 
                  RowBox[{"AlgSol", "//", "N"}], "]"}], "]"}]}], "]"}], "]"}],
              "]"}]}], "]"}]}], "]"}]}], "]"}], "/@", "TL"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Tile Length = \>\"", ",", "TL0"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "+", "#2"}], "&"}], ",", "0", ",", 
         RowBox[{"Abs", "[", 
          RowBox[{"N", "[", 
           RowBox[{"TL", "-", "TL0"}], "]"}], "]"}]}], "]"}], ">", 
       RowBox[{"$MachineEpsilon", " ", 
        RowBox[{"10", "^", "7"}]}]}], ",", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<Algebraic Number association error\>\"", "]"}], ";", 
       RowBox[{"Abort", "[", "]"}]}], ",", 
      RowBox[{
       RowBox[{"TL", "=", "TL0"}], ";"}]}], "]"}], ";"}], "\n"}]}]], "Input",
 CellChangeTimes->{{3.45464759696875*^9, 3.4546476670625*^9}, {
   3.45464771334375*^9, 3.4546477173125*^9}, {3.4546477731875*^9, 
   3.454647782953125*^9}, 3.45464781959375*^9, {3.45464812659375*^9, 
   3.454648151203125*^9}, {3.454648242390625*^9, 3.454648315765625*^9}, {
   3.454648352234375*^9, 3.454648528578125*^9}, {3.45464863740625*^9, 
   3.454648751640625*^9}, 3.45464895559375*^9, {3.4546490714375*^9, 
   3.45464907275*^9}, {3.4546496735625*^9, 3.45464968221875*^9}, 
   3.454662942234375*^9, 3.454663049765625*^9, {3.454713619671875*^9, 
   3.454713620890625*^9}, {3.454784181703125*^9, 3.454784196265625*^9}, {
   3.454784227484375*^9, 3.454784368671875*^9}, {3.454784413125*^9, 
   3.454784414015625*^9}, {3.454796276203125*^9, 3.45479628921875*^9}, 
   3.476800484121354*^9, {3.476800527999742*^9, 3.4768005388794727`*^9}, {
   3.4768811500630913`*^9, 3.476881164348444*^9}, {3.476882056548077*^9, 
   3.476882056996011*^9}, {3.476882311523078*^9, 3.476882315190722*^9}, 
   3.4768823749156322`*^9, {3.476882448574944*^9, 3.476882461228237*^9}, 
   3.476882809633317*^9, {3.476882886827498*^9, 3.476882890996201*^9}, {
   3.476882985805314*^9, 3.4768831207125893`*^9}, {3.476883166002185*^9, 
   3.476883186880919*^9}, {3.476883230965667*^9, 3.4768833698733063`*^9}, {
   3.4768834324331512`*^9, 3.4768835205633583`*^9}, 3.476883564745594*^9, {
   3.476883715932364*^9, 3.476883719956553*^9}, {3.4768860005172853`*^9, 
   3.4768860277595453`*^9}, {3.47688720148079*^9, 3.476887221684813*^9}, {
   3.476887265281405*^9, 3.4768872868492937`*^9}, {3.476887425837261*^9, 
   3.4768875395486403`*^9}, {3.476887611374868*^9, 3.476887614444819*^9}, {
   3.476888105644853*^9, 3.4768881074800377`*^9}, {3.4769420632395782`*^9, 
   3.476942069960595*^9}, {3.476942248966701*^9, 3.476942249767397*^9}, {
   3.476942439726256*^9, 3.476942459092444*^9}, {3.4769425205698967`*^9, 
   3.4769425241637897`*^9}, {3.4769429712700167`*^9, 3.476942976672827*^9}, {
   3.476943068233849*^9, 3.476943078006372*^9}, 3.476943334400581*^9, {
   3.4769433682692137`*^9, 3.4769433849638863`*^9}, 3.476943604493799*^9, {
   3.476944492191492*^9, 3.476944566465156*^9}, {3.476944841796228*^9, 
   3.476944895524291*^9}, {3.4769449471351957`*^9, 3.476944950558321*^9}, {
   3.4769450611086617`*^9, 3.476945073378706*^9}, 3.476946170219069*^9, {
   3.477206699700961*^9, 3.477206701444501*^9}, 3.494999634499565*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"diam", "=", 
    RowBox[{"Max", "[", "TL", "]"}]}], ";"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Find", " ", "a", " ", "prefix", " ", "with", " ", "2", "nd", " ", 
    "occurence", " ", "of", " ", "w"}], " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"w0", "=", 
    RowBox[{"NestWhile", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StringReplace", "[", 
        RowBox[{"#", ",", "Rl"}], "]"}], "&"}], ",", "w", ",", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"StringPosition", "[", 
            RowBox[{"#1", ",", "w"}], "]"}], "]"}], ">", "1"}], ")"}]}], 
       "&"}]}], "]"}]}], ";"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"Compute", " ", "the", " ", "return", " ", "word"}], " ", 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"rt0", "=", 
   RowBox[{"StringDrop", "[", 
    RowBox[{
     RowBox[{"StringTake", "[", 
      RowBox[{"w0", ",", 
       RowBox[{"Map", "[", 
        RowBox[{"First", ",", 
         RowBox[{"StringPosition", "[", 
          RowBox[{"w0", ",", "w", ",", "2"}], "]"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"-", "1"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<Return word of \>\"", ",", "w", ",", "\"\< is \>\"", ",", "rt0"}], 
    "]"}], ";"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"Associate", " ", "control", " ", "points", " ", 
    RowBox[{"(", 
     RowBox[{"left", " ", "end", " ", "points"}], ")"}], " ", "to", " ", 
    "tiles"}], " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"LS", "=", "0"}], ";", 
  RowBox[{"T0", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"i", "=", "1"}], ",", 
     RowBox[{"i", "\[LessEqual]", 
      RowBox[{"StringLength", "[", "w0", "]"}]}], ",", 
     RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"T0", "=", 
       RowBox[{"Append", "[", 
        RowBox[{"T0", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"StringTake", "[", 
            RowBox[{"w0", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "i"}], "}"}]}], "]"}], ",", "LS"}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"LS", "=", 
       RowBox[{"LS", "+", 
        RowBox[{"TL", "[", 
         RowBox[{"[", 
          RowBox[{"First", "[", 
           RowBox[{"First", "[", 
            RowBox[{"Position", "[", 
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{"First", ",", "Rl"}], "]"}], ",", 
              RowBox[{"StringTake", "[", 
               RowBox[{"w0", ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "i"}], "}"}]}], "]"}]}], "]"}], "]"}], 
           "]"}], "]"}], "]"}]}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Return", " ", "tile", " ", "length"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"al", "=", 
   RowBox[{"Last", "[", 
    RowBox[{"T0", "[", 
     RowBox[{"[", 
      RowBox[{"1", "+", 
       RowBox[{"StringLength", "[", "rt0", "]"}]}], "]"}], "]"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Q", "=", 
   RowBox[{"Last", "[", 
    RowBox[{"Eg", "/.", "Rep"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"C0", "=", 
    RowBox[{"diam", "+", 
     RowBox[{"al", "/", "Q"}]}]}], ";"}], " ", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Geometric", " ", "substitution", " ", "data"}], " ", 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"Rl0", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"For", "[", 
    RowBox[{
     RowBox[{"i", "=", "0"}], ",", 
     RowBox[{"i", "\[LessEqual]", 
      RowBox[{"k", "-", "1"}]}], ",", 
     RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"St", "=", 
       RowBox[{"{", "}"}]}], ";", 
      RowBox[{"L00", "=", "0"}], ";", 
      RowBox[{"Tes", "=", 
       RowBox[{
        RowBox[{"ToSt", "[", "i", "]"}], "/.", "Rl"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"StringLength", "[", "Tes", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"St", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"St", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"First", "[", 
                RowBox[{"First", "[", 
                 RowBox[{"Position", "[", 
                  RowBox[{
                   RowBox[{"Map", "[", 
                    RowBox[{"First", ",", "Rl"}], "]"}], ",", 
                   RowBox[{"StringTake", "[", 
                    RowBox[{"Tes", ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "j"}], "}"}]}], "]"}]}], "]"}], "]"}], 
                "]"}], "-", "1"}], ",", "L00"}], "}"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"L00", "=", 
          RowBox[{"L00", "+", 
           RowBox[{"TL", "[", 
            RowBox[{"[", 
             RowBox[{"First", "[", 
              RowBox[{"First", "[", 
               RowBox[{"Position", "[", 
                RowBox[{
                 RowBox[{"Map", "[", 
                  RowBox[{"First", ",", "Rl"}], "]"}], ",", 
                 RowBox[{"StringTake", "[", 
                  RowBox[{"Tes", ",", 
                   RowBox[{"{", 
                    RowBox[{"j", ",", "j"}], "}"}]}], "]"}]}], "]"}], "]"}], 
              "]"}], "]"}], "]"}]}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Rl0", "=", 
       RowBox[{"Append", "[", 
        RowBox[{"Rl0", ",", "St"}], "]"}]}], ";"}]}], "\[IndentingNewLine]", 
    "]"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Geometric", " ", "substitution"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Gsbst", "=", 
   RowBox[{"Function", "[", 
    RowBox[{"z", ",", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "+", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"Q", " ", 
            RowBox[{"Last", "[", "z", "]"}]}]}], "}"}]}], "&"}], ",", 
       RowBox[{"Rl0", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"First", "[", "z", "]"}], "+", "1"}], "]"}], "]"}]}], 
      "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Gs", "=", 
    RowBox[{"Function", "[", 
     RowBox[{"z", ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{"Gsbst", ",", "z"}], "]"}], ",", "1"}], "]"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Execute", " ", "Lemma", " ", "3.5", " ", "and", " ", "3.6"}], " ",
    "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"OvTwo1", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OvTwo", "=", 
   RowBox[{"{", "\[Infinity]", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"St1", "=", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], "}"}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"While", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Last", "[", 
      RowBox[{"Last", "[", "St1", "]"}], "]"}], "<", "C0"}], ",", 
    RowBox[{"St1", "=", 
     RowBox[{"Gs", "[", "St1", "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"While", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "OvTwo1", "]"}], "<", 
     RowBox[{"Length", "[", "OvTwo", "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OvTwo1", "=", "OvTwo"}], ";", "\[IndentingNewLine]", 
     RowBox[{"OvTwo", "=", 
      RowBox[{"Union", "[", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{
                RowBox[{"Function", "[", 
                 RowBox[{"z", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", 
                    RowBox[{"Last", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"First", "[", 
                    RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"MapThread", "[", 
                 RowBox[{"List", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"St1", ",", "i"}], "]"}], ",", 
                    RowBox[{"Drop", "[", 
                    RowBox[{"St1", ",", 
                    RowBox[{"-", "i"}]}], "]"}]}], "}"}], ",", "1"}], "]"}], 
                ",", "1"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", 
                RowBox[{"-", 
                 RowBox[{"Min", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Floor", "[", 
                    RowBox[{"C0", "/", 
                    RowBox[{"Min", "[", "TL", "]"}]}], "]"}], "+", "1"}], ",", 
                   RowBox[{
                    RowBox[{"Length", "[", "St1", "]"}], "-", "1"}]}], 
                  "]"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"Min", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Floor", "[", 
                    RowBox[{"C0", "/", 
                    RowBox[{"Min", "[", "TL", "]"}]}], "]"}], "+", "1"}], ",", 
                  RowBox[{
                   RowBox[{"Length", "[", "St1", "]"}], "-", "1"}]}], "]"}]}],
                "}"}]}], "]"}], "]"}], ",", "3"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C0"}], "<=", 
           RowBox[{"#", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[LessEqual]", "C0"}], "&"}]}], 
        "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"rp", ",", "\"\< \>\"", ",", 
       RowBox[{"Length", "[", "OvTwo", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rp", "++"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "OvTwo1", "]"}], "<", 
        RowBox[{"Length", "[", "OvTwo", "]"}]}], ",", 
       RowBox[{"St1", "=", 
        RowBox[{"Gs", "[", "St1", "]"}]}]}], "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Ov", "=", 
   RowBox[{"Union", "[", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{"Function", "[", 
              RowBox[{"z", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"First", "[", 
                  RowBox[{"z", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Last", "[", 
                   RowBox[{"z", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "al", "-", 
                  RowBox[{"Last", "[", 
                   RowBox[{"z", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
                 RowBox[{"First", "[", 
                  RowBox[{"z", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"MapThread", "[", 
              RowBox[{"List", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Drop", "[", 
                  RowBox[{"St1", ",", "i"}], "]"}], ",", 
                 RowBox[{"Drop", "[", 
                  RowBox[{"St1", ",", 
                   RowBox[{"-", "i"}]}], "]"}]}], "}"}], ",", "1"}], "]"}], 
             ",", "1"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{
              RowBox[{"Ceiling", "[", 
               RowBox[{"al", "/", 
                RowBox[{"Max", "[", "TL", "]"}]}], "]"}], "-", "1"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Min", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Floor", "[", 
                 RowBox[{"al", "/", 
                  RowBox[{"Min", "[", "TL", "]"}]}], "]"}], "+", "1"}], ",", 
               RowBox[{
                RowBox[{"Length", "[", "St1", "]"}], "-", "1"}]}], "]"}]}], 
            "}"}]}], "]"}], "]"}], ",", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "diam"}], "<=", 
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "<=", "diam"}], "&"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<# of initial overlaps \>\"", ",", 
    RowBox[{"Length", "[", "Ov", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.45464759696875*^9, 3.4546476670625*^9}, {
   3.45464771334375*^9, 3.4546477173125*^9}, {3.4546477731875*^9, 
   3.454647782953125*^9}, 3.45464781959375*^9, {3.45464812659375*^9, 
   3.454648151203125*^9}, {3.454648242390625*^9, 3.454648315765625*^9}, {
   3.454648352234375*^9, 3.454648528578125*^9}, {3.45464863740625*^9, 
   3.454648751640625*^9}, 3.45464895559375*^9, {3.4546490714375*^9, 
   3.45464907275*^9}, {3.4546496735625*^9, 3.45464968221875*^9}, 
   3.454662942234375*^9, 3.454663049765625*^9, {3.454713619671875*^9, 
   3.454713620890625*^9}, {3.454784181703125*^9, 3.454784196265625*^9}, {
   3.454784227484375*^9, 3.454784368671875*^9}, {3.454784413125*^9, 
   3.454784414015625*^9}, {3.454796276203125*^9, 3.45479628921875*^9}, 
   3.476800484121354*^9, {3.476800527999742*^9, 3.4768005388794727`*^9}, {
   3.4768811500630913`*^9, 3.476881164348444*^9}, {3.476882056548077*^9, 
   3.476882056996011*^9}, {3.476882311523078*^9, 3.476882315190722*^9}, 
   3.4768823749156322`*^9, {3.476882501578827*^9, 3.476882530637978*^9}, {
   3.476883803627179*^9, 3.476883810768721*^9}, {3.476884002866665*^9, 
   3.476884010788537*^9}, {3.476884285762425*^9, 3.476884286151524*^9}, {
   3.476884338854023*^9, 3.4768843456651373`*^9}, 3.476884522490806*^9, {
   3.476885111782701*^9, 3.476885130447403*^9}, {3.476885249323782*^9, 
   3.476885265161969*^9}, {3.476885329051257*^9, 3.476885330154387*^9}, {
   3.476885409986989*^9, 3.476885474665992*^9}, {3.476885912304379*^9, 
   3.476885928197688*^9}, {3.4769406895853033`*^9, 3.4769407017721663`*^9}, {
   3.476940737508316*^9, 3.476940909524332*^9}, {3.476940948924961*^9, 
   3.476940957836803*^9}, {3.476940995919237*^9, 3.4769410762442837`*^9}, {
   3.476941108716139*^9, 3.476941116718158*^9}, {3.476941160943475*^9, 
   3.476941184265485*^9}, {3.47694132590101*^9, 3.476941334249061*^9}, {
   3.4769414366244698`*^9, 3.476941439495441*^9}, {3.476941530129291*^9, 
   3.476941544884696*^9}, {3.476941749570862*^9, 3.476941780294052*^9}, {
   3.4769419614298763`*^9, 3.476941961918673*^9}, 3.476942156902903*^9, 
   3.4769445767684813`*^9, {3.476945498033263*^9, 3.476945502270075*^9}, {
   3.476945535956759*^9, 3.47694556073507*^9}, {3.4769456318721867`*^9, 
   3.476945776946162*^9}, {3.476945861824334*^9, 3.4769458632788143`*^9}, {
   3.476946332509934*^9, 3.4769463418039627`*^9}, {3.477206737980545*^9, 
   3.477206740242358*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Overlap", " ", "Inflation", " ", "function"}], " ", "*)"}], " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Rl1", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"z1", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"z1", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"Q", " ", 
                 RowBox[{"z", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "+", " ", 
                RowBox[{
                 RowBox[{"z1", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", 
                RowBox[{
                 RowBox[{"z1", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], ",", 
               RowBox[{
                RowBox[{"z1", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Flatten", "[", 
            RowBox[{
             RowBox[{"Outer", "[", 
              RowBox[{"List", ",", " ", 
               RowBox[{"Rl0", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"First", "[", "z", "]"}], "+", "1"}], "]"}], "]"}], 
               ",", 
               RowBox[{"Rl0", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"Last", "[", "z", "]"}], "+", "1"}], "]"}], "]"}], 
               ",", "1"}], "]"}], ",", "1"}], "]"}], ",", "1"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "diam"}], "<=", 
           RowBox[{"#", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "<=", "diam"}], "&"}]}], "]"}]}], 
      "]"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Overlap", " ", "algorithm"}], " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"Inf", "=", 
     RowBox[{"Function", "[", 
      RowBox[{"z", ",", 
       RowBox[{"Union", "[", 
        RowBox[{"Join", "[", 
         RowBox[{"z", ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"Map", "[", 
             RowBox[{"Rl1", ",", "z"}], "]"}], ",", "1"}], "]"}]}], "]"}], 
        "]"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     StyleBox["Ov1", "Text"], 
     StyleBox["=", "Text"], 
     RowBox[{
      StyleBox["NestWhile", "Text"], 
      StyleBox["[", "Text"], 
      RowBox[{
       StyleBox["Inf", "Text"], 
       StyleBox[",", "Text"], 
       StyleBox["Ov", "Text"], 
       StyleBox[",", "Text"], 
       StyleBox["UnsameQ", "MR"], 
       StyleBox[",", "MR"], 
       StyleBox[" ", "Text"], 
       StyleBox["All", "MR"]}], 
      StyleBox["]", "MR"]}]}], 
    StyleBox[";", "Text"]}], "\n", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "Ov1", "]"}], "<=", "100"}], ",", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Stable overlaps under inflation : \>\"", ",", "Ov1"}], 
       "]"}], ",", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<# of stable overlaps under inflation : \>\"", ",", 
        RowBox[{"Length", "[", "Ov1", "]"}]}], "]"}]}], "]"}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Overlap", " ", "graph"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Og", "=", 
     RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"z", ",", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{"Function", "[", 
              RowBox[{"x", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"z", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", "x"}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"z", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"MapThread", "[", 
          RowBox[{"List", ",", 
           RowBox[{"{", 
            RowBox[{"Ov1", ",", 
             RowBox[{"Map", "[", 
              RowBox[{"Rl1", ",", "Ov1"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
       ",", "1"}], "]"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Construct", " ", "and", " ", "draw", " ", "the", " ", "graph"}], 
    " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"Ov2", "=", 
     RowBox[{"Union", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Og", ",", "1"}], "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"gr0", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"z", ",", 
         RowBox[{
          RowBox[{"z", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
          RowBox[{"z", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
       RowBox[{"MapThread", "[", 
        RowBox[{"List", ",", 
         RowBox[{"{", 
          RowBox[{"Ov2", ",", 
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}], "}"}]}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"g", "=", 
     RowBox[{"FromOrderedPairs", "[", 
      RowBox[{"Og", "/.", "gr0"}], "]"}]}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Delete", " ", "vertices", " ", "without", " ", "outgoing", " ", 
     "edges"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LL", "=", "\[Infinity]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"While", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "Ov2", "]"}], "<", "LL"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"LL", "=", 
        RowBox[{"Length", "[", "Ov2", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Ov2", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{"Ov2", ",", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"OutDegree", "[", "g", "]"}], ",", "0"}], "]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"g", "=", 
        RowBox[{"InduceSubgraph", "[", 
         RowBox[{"g", ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"OutDegree", "[", "g", "]"}], ",", 
             RowBox[{"_", "?", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Size of potential overlap graph : \>\"", ",", " ", 
      RowBox[{"Length", "[", "Ov2", "]"}]}], "]"}], ";"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"Pick", " ", "out", " ", "all", " ", "coincidences"}], " ", 
    "*)"}], "\n", 
   RowBox[{
    RowBox[{"Ci", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "\[LessEqual]", 
       RowBox[{"Length", "[", "Ov2", "]"}]}], ",", 
      RowBox[{"i", "++"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"First", "[", 
           RowBox[{"Ov2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[Equal]", 
          RowBox[{"Last", "[", 
           RowBox[{"Ov2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}]}], " ", "&&", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Ov2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}]}], ",", 
        RowBox[{"Ci", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"Ci", ",", "i"}], "]"}]}]}], "]"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Ci", "\[Equal]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{
       RowBox[{
       "Print", "[", "\"\<Data Error: Trivial coincidences not found.\>\"", 
        "]"}], ";", 
       RowBox[{"Interrupt", "[", "]"}], ";"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Vertices", " ", "which", " ", "do", " ", "not", " ", "lead", " ", "to", 
     " ", "a", " ", 
     RowBox[{"coincidence", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Bd", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Tg", "=", 
     RowBox[{"ToAdjacencyMatrix", "[", 
      RowBox[{"TransitiveClosure", "[", "g", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Much", " ", "faster", " ", "than", " ", "using", " ", "shortest", " ", 
     "path", " ", "function"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"j", "=", "1"}], ",", 
      RowBox[{"j", "\[LessEqual]", 
       RowBox[{"Length", "[", "Ov2", "]"}]}], ",", 
      RowBox[{"j", "++"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Tg", "[", 
              RowBox[{"[", 
               RowBox[{"j", ",", "#"}], "]"}], "]"}], "&"}], ",", "Ci"}], 
           "]"}], "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{"Bd", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"Bd", ",", "j"}], "]"}]}]}], "]"}]}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"Ci", "==", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"Bd", "=", 
       RowBox[{"Range", "[", 
        RowBox[{"Length", "[", "Ov2", "]"}], "]"}]}]}], "]"}], ";"}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Bd", "=", 
     RowBox[{"Complement", "[", 
      RowBox[{"Bd", ",", "Ci"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<# of overlaps leading to coincidence = \>\"", ",", " ", 
      RowBox[{
       RowBox[{"Length", "[", "Ov2", "]"}], "-", 
       RowBox[{"Length", "[", "Bd", "]"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<# of non coincidence overlaps = \>\"", ",", 
      RowBox[{"Length", "[", "Bd", "]"}]}], "]"}], ";"}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Compare", " ", 
     RowBox[{"spectra", " ", ":", " ", 
      RowBox[{
      "Use", " ", "approximation", " ", "to", " ", "avoid", " ", "algebraic", 
       " ", "computation", " ", "of", " ", "spectra"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "Bd", "]"}], ">", "0"}], ",", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Spectral Radius = \>\"", ",", 
         RowBox[{"Rd1", "=", 
          RowBox[{"Max", "[", 
           RowBox[{"Abs", "[", 
            RowBox[{"Eigenvalues", "[", 
             RowBox[{
              RowBox[{"ToAdjacencyMatrix", "[", "g", "]"}], "//", "N"}], 
             "]"}], "]"}], "]"}]}], ",", " ", "\"\<,  PF eigenvalue =\>\"", 
         ",", 
         RowBox[{"Q", "//", "N"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{
        "\"\<Radius of induced graph from non coincidence overlaps = \>\"", 
         ",", 
         RowBox[{"Rd2", "=", 
          RowBox[{"Max", "[", 
           RowBox[{"Abs", "[", 
            RowBox[{"Eigenvalues", "[", 
             RowBox[{
              RowBox[{"ToAdjacencyMatrix", "[", 
               RowBox[{"InduceSubgraph", "[", 
                RowBox[{"g", ",", "Bd"}], "]"}], "]"}], "//", "N"}], "]"}], 
            "]"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Rd2", "<", "Rd1"}], ",", 
         RowBox[{"Print", "[", "\"\<Coincidence\>\"", "]"}], ",", 
         RowBox[{"Print", "[", "\"\<No Coincidence \>\"", "]"}]}], "]"}]}], 
      ",", 
      RowBox[{"Print", "[", "\"\<No edge overlap found\>\"", "]"}]}], "]"}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.476879395883122*^9, 3.4768794408214617`*^9}, {
   3.476882611160383*^9, 3.4768826178529778`*^9}, 3.4768838742317953`*^9, {
   3.476884165591762*^9, 3.476884167520341*^9}, {3.47688480222832*^9, 
   3.4768848134962587`*^9}, {3.476945220553893*^9, 3.476945229336556*^9}, {
   3.476945326059135*^9, 3.476945329047696*^9}, {3.4769469990476217`*^9, 
   3.476947018278446*^9}, {3.477206836482736*^9, 3.477206839857126*^9}}]
},
WindowToolbars->{},
WindowSize->{1018, 706},
WindowMargins->{{-2, 2}, {2, Automatic}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
FrontEndVersion->"7.0 for Linux x86 (64-bit) (December 18, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 17404, 417, 957, "Input"],
Cell[17952, 439, 11713, 305, 715, "Input"],
Cell[29668, 746, 16234, 419, 1133, "Input"],
Cell[45905, 1167, 12920, 355, 1648, "Input"]
}
]
*)

(* End of internal cache information *)
